#!/usr/bin/env python
# coding=UTF-8
#
# Copyright (C) 2010 Stefanos Harhalakis
#
# This file is part of wifieye.
#
# wifieye is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# wifieye is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with wifieye.  If not, see <http://www.gnu.org/licenses/>.
#
# $Id: graph.py 2238 2010-02-12 19:29:16Z v13 $

from PyQt4 import QtCore
from PyQt4.QtCore import Qt
from PyQt4.QtGui import *

import sys

class WifiColors:
    def __init__(self):
	self.colors=[
	    Qt.green,
	    Qt.cyan,
	    Qt.magenta,
	    Qt.yellow,
	    Qt.red,
	    Qt.darkGreen,
	    Qt.darkCyan,
	    Qt.darkMagenta,
	    Qt.darkYellow,
	    Qt.darkRed,
	    Qt.blue,
	    Qt.darkBlue,
	    Qt.gray,
	    Qt.darkGray
	    ]
	
    def get(self, cnt):
	return(self.colors[cnt%len(self.colors)])

    # Return the number of available colors
    def num(self):
	return(len(self.colors))

class BaseGraph(QWidget):
    def __init__(self):
	QWidget.__init__(self)
	
	self.padding_top=20	# This is fixed
	self.space_bottom=80	# This too

	self.width=780	    # Total width - This changes with resizes

	self.bar_x=80
	self.bar_y=350

	self.height=self.bar_y - self.padding_top

	self.colors=WifiColors()
    # End of __init__()

    def resizeEvent(self, event):
	sz=event.size()
	w=sz.width()
	h=sz.height()

	self.height=h
	self.width=max(w, 0)
	self.bar_y=max(h - self.space_bottom, 0)
# vim: set ts=8 sts=4 sw=4 noet formatoptions=r ai nocindent:

